----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    10:12:52 12/04/2009 
-- Design Name: 
-- Module Name:    char_counter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity char_counter is
	port (
		CLK_in	: in	STD_LOGIC;
		RST_in	: in	STD_LOGIC;
		UP_in		: in	STD_LOGIC;
		DOWN_in	: in	STD_LOGIC;
		CHAR_out : out STD_LOGIC_VECTOR(7 downto 0)		
		);

end char_counter;

architecture Behavioral of char_counter is
	signal q: STD_LOGIC_VECTOR(7 downto 0);
	signal condition_up, condition_down: STD_LOGIC;

	constant lower_bound: STD_LOGIC_VECTOR(7 downto 0) := "00110000";	-- znak 0
	constant upper_bound: STD_LOGIC_VECTOR(7 downto 0) := "01011010"; -- znak Z

begin
	
	condition_up <= '1' when q = upper_bound else '0';
	condition_down <= '1' when q = lower_bound else '0';
	CHAR_out <= q;
	
	process(CLK_in) 
	begin
		if (rising_edge(CLK_in)) then
			if (RST_in = '1') then
				q <= lower_bound;
			elsif (UP_in = '1') then
				if (condition_up = '1') then
					q <= lower_bound;
				else
					q <= q + 1;
				end if;
			elsif (DOWN_in = '1') then
				if (condition_down = '1') then
					q <= upper_bound;
				else
					q <= q - 1;		
				end if;
			end if;
		end if;	
	end process;

end Behavioral;

