----------------------------------------------------------------------------------
-- Company: FRI
-- Engineer: Miha Moskon
-- 
-- Create Date:    14:48:51 09/28/2007 
-- Design Name: 
-- Module Name:    counter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity counter is
	generic(
		size : integer := 8); -- privzeta velikost je 8
	port(
		CLK_in	: IN STD_LOGIC;
		WE_in	: IN STD_LOGIC;
		VALUE_in	: IN STD_LOGIC_VECTOR(size-1 downto 0);
		COUNT_UP_out	: OUT STD_LOGIC);		
end counter;

architecture Behavioral of counter is
	signal value	: STD_LOGIC_VECTOR(size-1 downto 0);
	signal count	: STD_LOGIC;
	signal COUNT_UP	: STD_LOGIC;
begin

	-- IO ASSIGNMENT
	COUNT_UP_OUT	<= COUNT_UP;	
	
	-- AVTOMAT
	
	process (CLK_in)
	begin
		if (rising_edge(CLK_in)) then
			if (WE_in = '1') then
				value <= VALUE_in;
			elsif (count = '1') then
				value <= value - 1;
			else
				value	<= (others => '0');
			end if;
		end if;
	end process;
	
	COUNT_UP <= '1' when ((value = 0) AND (WE_in = '0')) else
					'0';
	count		<= '0' when value = 0 else
					'1';
end Behavioral;

